\ Block 7 Fed1A readblock, saveblock, print
0 background !
forget Forth_Editor
variable Forth_Editor

: gul ( block -- ) \ gettext update load
   dup 1 50 within 0= if exit then
   dup block drop wipe gettext update flush
   load
;

: nload ( block -- ) \ force new load from SD card
   flush   -1 actBlock ! load ;

: erline \ Clear entire line ^[[2K
   27 emit ." [2K" ;

: magenta 5 fcolor ; \ set color

bBuf 32768 - constant fedBuf$
100 value lWidth# \ includes LF

4 value fedStartLine# \ top of screen used
65 value fedHeight#
1 value marginsFlag#
create holdBuf 16 allot
0 value setHold#
0 value iHold#
0 value startList#
0 value lastLine#
0 value actLine#
0 value maxLines#
0 value actCol#
0 value blockMarker#
10 value fedBlock#
variable fedUpdated   0 fedUpdated !
variable actFedBlock  0 actFedBlock !
variable listFiFlag   0 listFiFlag !
0 value key#
variable updateLiFlag

: fedFlush \ write back block if updated
   fedUpdated @ if
      fedBuf$ actFedBlock @ bSize *   bSize fwriteBlock
      0 fedUpdated !
   then
;

: fedUpdate \ mark as updated
   1 fedUpdated !
;

: fedBlock ( block -- addr ) \ load directly into fedBuf$
   dup actFedBlock @ = if drop fedBuf$ exit then
   fedFlush   dup actFedBlock !
   bSize * ( startpos )   fedBuf$ swap   bSize
   freadBlock  ( textbuf startpos length -- length)
   drop fedBuf$
;

: fillLine \ fill the actual line in fedBuf$ to lWidth# with BLANKS
   begin
   actCol# lWidth# 1- < while
      32 fedBuf$ actLine# lWidth# * + actCol# + c!
      1 +to actCol#
   repeat
   10 fedBuf$ actLine# lWidth# * + actCol# + c! \ add LF
   0 to actCol#
   1 +to actLine#
;

: fedExpand ( block -- ) { , inch# col# line# p# } \ read text into bBuf and expand into fedBuf$
   dup actFedBlock !
   block drop \
   fedBuf$ 32768 0 fill \ fill with zero
   0 to actCol#
   0 to actLine#
   bBuf to_p#
   begin
      p# c@ to_inch#    1 +to_p# \ get next char
      inch# 10 = if fillLine then
      inch# 32 127 within if
         inch# fedBuf$ actLine# lWidth# * + actCol# + c!
         1 +to actCol#
         actCol# lWidth# = if
            0 to actCol#
            1 +to actLine#
         then
      then
   inch# 0= until
   actLine# to maxLines#
; forgetLocals


: prtComment2 loc_a ( pointer -- new pointer ) \ prt comments green
   a> 1+ c@ 32 <> if a> endloc exit then
   a> c@   dup 40 =   swap 92 = or if
      green
      begin
         a> c@ >c
         c> 0= if normal a> endloc exit then
         c> 31 > if
            c> emit
         then
         1 +>a
      c> 41 =   c> 10 = or until
      normal
   then
   a>
endloc ;


: prtLineHigh loc_a ( linestart$ -- ) \ display colored until CR
   \ cr
   a> >e
   begin
      begin \ leading space cr or NULL
         a> c@ >c
         c> 0= c> 10 = or if endloc exit then
         c> 32 =   if \ blank
            c> emit 1 +>a
         then
      c> 32 > until
      a> prtComment2 >b
      b> c@ 0=   b> e> <>   b> 1- c@ 10 = and or
      if endloc exit then
      a> b> = if
         a> lineBuf$ copyword >a
         lineBuf$ find$ >b \ find link field
         b> 0 > if b> prtCWord
         else yellow lineBuf$ print$ normal
         then
      else
         b> >a
      then
   again
endloc ;

: .decs { n# dig# -- } \ print n# right justified
   1
   dig# 0 do
   10 *
   loop
   \ dup .
   dig# 0 do
      dup n# > if space then
      10 /
   loop
   drop
   n# .
; forgetLocals

: listLine ( line -- ) \ number relative to startList#
   erline
   startList# +
   marginsFlag# if
      dup 3 .decs
      dup blockMarker# = if
         magenta ." M"
      else ."  " then
   then
   lWidth# * fedBuf$ + prtLineHigh
   marginsFlag# if ." |" then
   cr
;

: doListFile { , i# } \ print the whole sceen newly
   0 listFiFlag ! \ dup w@ swap 2 + w! \ mark done
   \ prtHeader
   normal \ %plain
   0 3 fedStartLine# + at-xy \ %xy
   0 to_i#
   \ 0 to comFlag#
   begin
   startList# i# + maxLines# <   i# fedHeight# < and while
      i# listLine
      1 +to_i#
   repeat
   begin
   i# fedHeight# < while
      erline cr
      1 +to_i#
   repeat
   \ 0 to comFlag#
; forgetLocals

: listFile \ mark screen update to be done
   listFiFlag ++
;

scanDefs \ update source fields
--> \ load next block
\