\ Block 9 Fed9A
0 background !
forget Forth_Editor5
variable Forth_Editor5

: centerAddr ( addr ) \ if near borders center on screen
   addrRange
   fedBuf$ - dup lWidth# / to actLine#
   lWidth# mod to actCol#
   actLine# startList# 3 + startList# fedHeight# + 3 - within 0= if
      actLine# fedHeight# 2 / - 0 max to startList#
      listFile
   then
;

: doLineUpdate \ print actual line newly
   \ 0 1 %xy %erline %plain fedFile$ print$ ."  " actLine# . actCol# .
   0 updateLiFlag ! \ mark done
   0 actLine# startList# - 3 + fedStartLine# + at-xy
   actLine# startList# - listLine
;

: lineUpdate \ mark to be updated
   updateLiFlag ++
;

0 value key#

: insChar ( -- ) \ insert key#
   fedBuf$ actLine# lWidth# * + actCol# +
   actCol# 2 + lWidth# < if
      dup \ source
      dup 1+ \ dest
      lWidth# actCol# - 2 - \ cnt
      cmove> \ <cmove
   then
   key# swap c!
   actCol# 1+ lWidth# 2 - min to actCol#
;

: bsChar ( -- ) \ backspace
   actCol# 0= if exit then
   fedBuf$ actLine# lWidth# * + actCol# + \ source
   dup 1- \ dest
   lWidth# actCol# - 1- \ cnt
   cmove
   32 fedBuf$ actLine# 1+ lWidth# * + 2 - c!
   actCol# 1- 0 max to actCol#
;

: delChar ( -- ) \ delete char
   fedBuf$ actLine# lWidth# * + actCol# + 1+ \ source
   dup 1- \ dest
   lWidth# actCol# - 1- \ cnt
   cmove
   32 fedBuf$ actLine# 1+ lWidth# * + 2 - c!
   \ actCol# 0 maxs to actCol#
;

: newBlankLine \ under cursor
   \ bufFullFlag ~~ 19 emit \ xoff
   fedBuf$ actLine# 1+ lWidth# * + \ source next line
   actLine# 1+ maxLines# < if
      dup \ source
      dup lWidth# + \ dest
      maxLines# actLine# 1+ - lWidth# * \ cnt
      cmove> \ <cmove
      \ 4/ <lmove
   then
   lWidth# 1- 32 fill \ cr bleibt erhalten
   1 +to maxLines#
   1 +to actLine#
;

: insBlankLine \ above
   fedBuf$ actLine# lWidth# * +
   dup \ source
   dup lWidth# + \ dest
   maxLines# actLine# - lWidth# * \ cnt
   cmove>
   lWidth# 1- 32 fill
   1 +to maxLines#
;

create cutBuf$ 256 allot

: cutLine \ delete actual line into cutBuf$
   fedBuf$ actLine# lWidth# * + \ source
   cutBuf$ \ dest
   lWidth# \ cnt
   cmove \ copy
   actLine# 1+ maxLines# < if
      fedBuf$ actLine# lWidth# * +
      dup lWidth# + \ source
      swap
      maxLines# 1- actLine# - lWidth# * \ cnt
      cmove
   then
   -1 +to maxLines#
   \ -1 +to actLine#
   actLine# maxLines# 1- min to actLine#
;

: insCutLine \ insert a line from cutBuf$
   insBlankLine
   cutBuf$ \ source
   fedBuf$ actLine# lWidth# * + \ dest
   lWidth# \ cnt
   cmove
;

: a>A ( lower -- upper ) \ convert case of char
   dup 97 122 within if
      32 -
   then
;


: esc5b ( code -- ) \ ^[[n cursor movement
   switch \ ansi key sequences use $1b $5b ?? ??
         65 case \ up
            actLine# 1- 0 max to actLine# cur2Add centerAddr break
         66 case \ down
            actLine# 1+
            maxLines# 1- min to actLine# cur2Add centerAddr break
         67 case \ right
            actCol# 1+ lWidth# 2 - min to actCol# break
         68 case \ left
            actCol# 1- 0 max to actCol# break
         49 case wkey drop 0 to actCol# break \ home
         52 case wkey drop findEnd break \ end
         53 case wkey drop \ page up
            startList# fedHeight# 5 * 6 / - 0 max
            dup to startList#
            3 + maxLines# 1- min to actLine#
            listFile break
         54 case wkey drop \ page down
            startList# fedHeight# 5 * 6 / +
            maxLines# fedHeight# 5 * 6 / - min
            0 max
            dup to startList#
            3 + maxLines# 1- min to actLine#
            listFile break
;

: sedesc \ ESC combinations
   a>A switch \ esc <key> commands
      $5b case wkey esc5b break \ ^[[
    \ fnc_    $4f case wkey fnckey break
    \ del_    $7f case tdel break
;

: fedKey \ react to key#
   key# switch
      32 126 <case> \ normal text input
         insChar lineUpdate break
      8 case \ BS
         bsChar lineUpdate break
      127 case \ del
         delChar lineUpdate break
      10 case \ CR wkey drop
         newBlankLine listFile
         0 to actCol# break
      9 case \ tab
         32 to key# insChar insChar insChar
         lineUpdate break
      $1B case wkey sedesc break \ ESC
      7 case \ G list defs and offer Goto
         fedFillDefs listFile break
      11 case \ K Marker setzen
         setHold listFile break
      14 case \ N zum naechsten Marker springen
         jumpHold break
      18 case \ R
         marginsFlag# 0= 1 and to marginsFlag# listFile break
      23 case \ W print glossary
         prtCurGlos break
      24 case \ ^X cutline
         cutLine listFile break
      22 case \ ^V insert line
         insCutLine listFile break
;

: findLastLine \ find last line of fedBuf$ to maxLines#
   fedBuf$
   begin
      1+
   dup c@ 0= until
   fedBuf$ -
   lWidth# / to maxLines#
;

: reload \ load fedBlock#
   fedBlock# nload
;

: list ( block -- ) \ list block in color
   block drop
   colBuf
;

: fed \ forth editor starts editing the block in fedBlock#
   page
   -1 actFedBlock ! \ force new load
   fedBlock# fedBlock drop \ load file
   findLastLine
   doListFile
   conkey drop
   6 marginsFlag# * actCol# +   actLine# startList# - 3 + fedStartLine# + at-xy
   begin
      conkey to key#
      key# 0= if
            listFiFlag @ if doListFile
            6 marginsFlag# * actCol# +   actLine# startList# - 3 + fedStartLine# + at-xy
         then
         pause
      else
         fedKey
         updateLiFlag @ if doLineUpdate then
         6 marginsFlag# * actCol# +   actLine# startList# - 3 + fedStartLine# + at-xy
      then
   key# 17 = until
   0 fedHeight# 3 + fedStartLine# + at-xy   erline
   cr ." Y for store "
   wkey 89 = if
      0 fedBuf$ maxLines# lWidth# * + 1+ c! \ mark end
      fedUpdate fedFlush then
;

: nFed ( blocknr -- ) \ start fed with blocknumber, sets fedBlock#
   to fedBlock#
   fed
;

: eFed ( blocknr -- ) \ start fed with block, will be expanded first, sets fedBlock#
   dup 0 499 within if
      dup to fedBlock#
      fedExpand fedUpdate fedFlush
      fed
   else drop then
;

: prt2000
   2000 0 do
      i 20 mod 0= if cr then
      fedBuf$ i + c@ .
   loop
;

scanDefs \ update source fields
multitask

