\ block 2 Blocks words
0 background !
forget MarkBlock1
variable MarkBlock1

: wipe ( clear the actual block buffer )
   bBuf bSize 0 fill ;

: gu ( block -- ) ( gettext update load )
   block drop wipe gettext update flush
;

: ?dup dup if dup then ;

: wkey ( -- char ) ( wait for char )
   begin conkey ?dup until ;

: <> = 0= ;

: ++ ( addr ) \ add one to variable
   dup @ 1+ swap ! ;
   
: clearstack \ clear parameter stack
   depth ffor drop fnext ;

: untrace 2000000 trace! ; \ stop tracing

: --> \ load next block too
   actBlock @ 1+ block inP ! ;
   
\ { Screen control and colors 
: scolor ( color -- ) 27 emit 91 emit 48 + emit 109 emit ;
: bold 1 scolor ; : normal 0 scolor ;
: fcolor ( col ) 27 emit 91 emit 51 emit 48 + emit 109 emit ;
: red 1 fcolor ; : green 2 fcolor ; : yellow 3 fcolor ; : blue 4 fcolor ;

: .3d ( n -- ) \ { print 2 digits without blank
    dup 99 > if
      49 emit
      100 mod
   then
    dup 9 > if
        dup 10 /
        48 + emit
    then
    10 mod 48 + emit
; \ }

: at-xy ( col row -- ) \ { position cursor at col row, starting with 0 0
    27 emit 91 emit
    1+ .3d
    59 emit \ ;
    1+ .3d
    72 emit
; \ }

: page ( -- ) \ { clear page
    27 emit 91 emit
    50 emit
    74 emit
    0 0 at-xy
; \ }


variable bPoint

: mkBlocks ( CLEARS BLOCKS)
   wipe
   maxBlocks# 0 do
      update
      i actBlock ! flush
   loop
;

: prtBuf ( -- ) \ display bBuf
   0 bPoint !
   begin 
      bBuf bPoint @ + c@
      dup 31 > if dup emit then
      dup 10 = over 12 = or if dup emit then
      bPoint ++ 
   0 =   bPoint @ bSize = or until
;

: cr 10 emit ;
: space 32 emit ;
variable lineBuf$ 128 allot

: index ( -- ) \ display all first lines of blocks
   cr
   maxBlocks# 0 do
      i bSize * ( startpos )   lineBuf$ swap   100 
      freadBlock  ( textbuf startpos length -- length) drop
      0 lineBuf$ 100 + c!
      0 bPoint !
      lineBuf$ bPoint @ + c@ dup   92 =   swap 40 =   or if 
         cr ( ." Block " ) i . space
         begin 
            lineBuf$ bPoint @ + c@
            dup 31 > if dup emit then
            bPoint ++ 
         32 <  until
      then
   loop
;

\             ISNORMAL, ISLOOP, ISSTRUCT, ISDATA, ISIO, ISASS
create colTab 7 c, 1 c, 6 c, 4 c, 7 c, 7 c, 0 c, 0 c,

: prtCWord loc_a ( lfa -- ) \ print word in color
   a> 8 + c@   
   $7 and colTab + c@ fcolor \ get color
   a> 12 + print$
   normal
endloc ;

: cwords loc \ print words in color
   cr
   context @ >a
   begin
      a> prtCWord space
      a> @ >a \ crawl link fields
   a> 0= until
endloc ;

: copyword loc_ab ( source dest -- new_source ) 
   begin 
      a> c@ >c \ getchar
      c> 32 > if 
         c> b> c! 
         1 +>a   1 +>b
         then
   c> 33 < until
   0 b> c! \ end mark
   a>
endloc ;

: prtComment loc_a ( pointer -- new pointer ) \ prt comments green from /_ or (_ to lf )
   a> 1+ c@ 32 <> if a> endloc exit then
   a> c@   dup 40 =   swap 92 = or if
      green
      begin 
         a> c@ >c
         c> 0= if normal a> endloc exit then
         c> emit
         1 +>a
      c> 41 =   c> 10 = or until
      normal
   then
   a>
endloc ;
   
: colBuf loc ( -- ) \ display bBuf in color
   cr
   bBuf >a
   begin 
      begin \ leading space cr or NULL
         a> c@ >c
         c> 0= if endloc exit then
         c> 32 =   c> 10 = or if \ blank or cr
            c> emit 1 +>a 
         then
      c> 32 > until
      a> prtComment >b
      b> c@ 0= if endloc exit then
      a> b> = if
         a> lineBuf$ copyword >a
         lineBuf$ find$ >b \ find link field
         b> 0 > if b> prtCWord 
         else yellow lineBuf$ print$ normal
         then
      else          
         b> >a
      then
   again
endloc ;

\ ############################################################
\ { modules http //www.forth.org/fd/FD-V02N5.pdf
: INTERNAL ( -- addr ) context @ ( Start of hidden/local definitions ) ;
: EXTERNAL ( -- addr ) here@ ( Start of visible definitions. Adresse des aktuellen Linkfields ) ;
: MODULE ( addr1 addr2 -- ) ! ( Ueberspringen der Def zwischen INTERNAL und EXTERNAL ) ;

\ }

: prtDefs loc \ prints 1st lines of buffer
   cr
   bBuf >a
   begin
      a> c@ >c 
      c> 58 = if 1 >d then \ set flag
      c> 10 = d> and if cr then
      c> 31 < if 0 >d then \ clear flag
      d> if c> emit then
      1 +>a
   c> 0= until       
endloc ;

--> \ load next block too

\ 
