\ block 3 Named locals, switch...case...break
forget NamedLocals_Lib
variable NamedLocals_Lib

: cells 4 * ;

create  nextName$ 25 allot    0 nextName$ !

: cpy$ loc_ab ( source dest -- ) \ copy null terminated string
   begin 
   a> c@ >c 
   c> b> c!
   1 +>a
   1 +>b
   c> 0= until
endloc ;

: append$ ( source dest -- ) \ append null terminated string
   begin \ find end of destination
   dup c@ 0 <> while
      1+
   repeat
   cpy$
;

: getWord ( -- address ) \ get next word of the input stream into lineBuf$
   begin \ skip leading whitespace
   inP @ c@ dup 0 <>   swap   33 < and while
      inP ++
   repeat
   inP @ lineBuf$ copyword inP !
   lineBuf$
;

INTERNAL \ named locals 

create locNames \ table holds name field address of locals
' a> 20 - , ' >a 20 - , ' +>a 20 - ,
' b> 20 - , ' >b 20 - , ' +>b 20 - , 
' c> 20 - , ' >c 20 - , ' +>c 20 - , 
' d> 20 - , ' >d 20 - , ' +>d 20 - , 
' e> 20 - , ' >e 20 - , ' +>e 20 - , 

create locinits \ table holds codes for inits
   ' loc @ , ' loc_a @ , ' loc_ab @ , ' loc_abc @ , ' loc_abcd @ , ' loc_abcde @ , 

variable locStat# \ 0= names , 1= comment, 2 end , 3= noninit
variable locStack#  \ number of locals from stack
variable locNum#    \ total number of locals

: patchName loc_ab ( name$ number -- ) \ patch local name into dictionary
   a>   b> 12 * locNames + @ cpy$
   s" to_" b> 12 * 4 + locNames + @ cpy$
   a>    b> 12 * 4 + locNames + @ append$
   s" +to_" b> 12 * 8 + locNames + @ cpy$
   a>    b> 12 * 8 + locNames + @ append$
endloc ;

' endloc @ constant (endloc) 
' ; constant dosemicolon 

EXTERNAL 

: forgetLocals \ patch back the standard names
   s" a>" locNames 0 cells + @ cpy$
   s" >a" locNames 1 cells + @ cpy$
   s" +>a" locNames 2 cells + @ cpy$
   s" b>" locNames 3 cells + @ cpy$
   s" >b" locNames 4 cells + @ cpy$
   s" +>b" locNames 5 cells + @ cpy$
   s" c>" locNames 6 cells + @ cpy$
   s" >c" locNames 7 cells + @ cpy$
   s" +>c" locNames 8 cells + @ cpy$
   s" d>" locNames 9 cells + @ cpy$
   s" >d" locNames 10 cells + @ cpy$
   s" +>d" locNames 11 cells + @ cpy$
   s" e>" locNames 12 cells + @ cpy$
   s" >e" locNames 13 cells + @ cpy$
   s" +>e" locNames 14 cells + @ cpy$
;

: { \ begin locals Syntax { local1 local2 ... , nonInitLocal ... -- comment } \ 
    forgetLocals
    0 locStat# !    0 locStack# !   1 locNum# ! 
    begin
        getWord drop \ into lineBuf$
        lineBuf$ c@ 44 ( [char] , ) = if 
            getWord drop \ into lineBuf$
            3 locStat# ! then
        lineBuf$ c@ 45 ( [char] - ) = if 1 locStat# ! then
        lineBuf$ c@ 125 ( [char] } ) = if 2 locStat# ! then
        locStat# @ 0 = if
            lineBuf$ locNum# @ 1 - patchName
            1 locNum# +!
            1 locStack# +! \ inited variable
        then
        locStat# @ 3 = if
            lineBuf$ locNum# @ 1 - patchName
            1 locNum# +!
        then  
    locStat# @ 2 = until
    locinits locStack# @ cells + @ , \ compile init
; immediate


: isstruct! \ mark as structure word
   context @ 8 + c@ 2 or context @ 8 + c! ;

: ; \ new version with locals
   locNum# @ if (endloc) ,   0 locNum# !   then
   \ (exit) ,
   dosemicolon execute
; immediate isstruct!

MODULE

: locTest { l1# l2# , l3# -- } \ a test for named locals
   l1# l2# - to_l3#
   l3#
; forgetLocals

\ macros and switch...case ############################################################

: within { x# lo# hi# -- flag } \  true if n is within range of low and high inclusive
   x# lo# 1- >
   x# hi# 1+ < and 
; forgetLocals 

: eval$ ( stringaddr -- ) \ save inP evaluate restore inP
   inP @ >r evaluate r> inP ! ;

\ switch, case, <case> and break are macros, which compile their string, if in compile state
\ uses variable at offset 9 longs in user space 
: switch ( value -- ) \ save in switchvar
   s" up@ 9 cells + ! " eval$ ; immediate isstruct! 
: case ( value -- ) \ case....break compare with switchvar 
   s" up@ 9 cells + @ = if " eval$ ; immediate isstruct! 
: <case> ( value1 value2 -- ) \ case....break compare within switchvar 
   s" up@ 9 cells + @ rot rot within if " eval$ ; immediate isstruct! 
: break ( -- ) \ case...break exits!
   s" exit then " eval$ ; immediate isstruct!
   
: casetest ( val -- ) \ a test for switch....case...break
    switch
       1 case ." one" break
       2 case ." two" break
       3 case ." three" break
       4 10 <case> ." between four and ten" break
    ." default"
;





--> \ load next block also

\ € 
\ } named locals
