\ Block 4 Help
forget Help_Lib
variable Help_Lib

: printLine { address# , char# -- } \ print to line end
   begin
      address# c@ to_char#
      char# 31 > if
         char# emit
         1 +to_address#
      then
   char# 32 < until
; forgetLocals

: findLineStart { addr# -- new_addr } \ scans until pos after CR, 0 for end
   begin
      addr# c@ dup 0= if endloc exit then \ end of text 0
      1 +to_addr#
   10 = until
   addr#
; forgetLocals

: cmpWord$ { w1# w2# , c1# c2# flag# -- flag# } \ compare limited by whitespace
   -1 to_flag#
   begin
      w1# c@ to_c1#
      w2# c@ to_c2#
      c1# 32 max   c2# 32 max   =   flag# and to_flag#
      \ cr c1# emit c2# emit flag# .
      1 +to_w1#   1 +to_w2#
   c1# 33 <   c2# 33 < or   flag# 0= or until
   flag#
; forgetLocals

: scanDefs loc \ fills source field from actual buffer
   cr
   bBuf >a
   0 >c
   begin
      \ a> @ $FFFFFF and >c
  a> c@ 16 <<   c> 8 >> or >c \ lies char als MSB
      c> $203A0A = if \ found LF Colon Blank
         a> 1+ lineBuf$ copyword drop
         \ space lineBuf$ print$
         lineBuf$ find$ >b \ gets lfa
         b> if
            \ b> .
            actBlock @ 22 << a> 1+ bBuf - +   b> 4 + !
         then
      then
      1 +>a
    a> c@ 0= until
endloc ;

: scanSource \ fills source fields from first buffers
   inP @ actBlock @ \ keep block and position on stack
   6 1 do
      cr ." Block " i .
      i block drop
      scanDefs
   loop
   block drop \ get back block
   inP ! \ get back position
;

: prtDefLine ( cfa -- ) \ print from dictionary
   28 - @ ?dup if \ war 25
      cr dup 22 >> dup . space block drop
      $FFFFF and bBuf + printLine
   then
;

: prtDef ( < word> -- ) \ print definition
   ' prtDefLine ;

: spaces ( n -- ) \ emit n spaces
   ffor 32 emit fnext ;

: dots ( n -- ) \ emit n dots
   ffor 46 emit fnext ;

: length$ loc_a ( addr1 -- n ) \ { give length of NULL terminated string
    0 >b \ in b ist die Laenge
    begin
    a> b> + c@ while \ nicht zu ende
        b> 1 + >b
    repeat
    b> \ gib das Ergebnis zurck
endloc ; \ }

: gwords loc \ words with glossary
   cr
   context @ >a
   begin
      cr a> prtCWord space
      a> 4 + @ ?dup if
         15 a> 9 + length$ - 1 max spaces
         \ 9 emit
         dup 22 >>
         dup . space
         block drop
         $FFFFF and bBuf + printLine
      then
      a> @ >a \ crawl link fields
   a> 0= until
endloc ;


: colSource loc ( cfa -- ) \ display source in color
   28 - @ ?dup if \ war 25
      cr dup 22 >> dup ." Block: " . cr
  block drop
      $FFFF and bBuf + >a \ start of source
      cr
      begin
         begin \ leading space cr or NULL
            a> c@ >c
            c> 59 = if c> emit cr endloc exit then \ semicolon
            c> 0= if endloc exit then
            c> 32 =   c> 10 = or if \ blank or cr
               c> emit 1 +>a
            then
         c> 32 > until
         a> prtComment >b
         b> c@ 0= if endloc exit then
         a> b> = if
            a> lineBuf$ copyword >a
            lineBuf$ find$ >b \ find link field
            b> 0 > if b> prtCWord
            else yellow lineBuf$ print$ normal
            then
         else
            b> >a
         then
      again
   then
endloc ;

: prtSource ( < word> -- ) \ print source in color
   ' colSource ;


-->

\
