\ Block 5 Cooperative Multitasking
0 background !
forget Multitasking_Lib
variable Multitasking_Lib

0 up@ ! \ reset link list

: addTask { ua# cfa# , unext# -- } \ add task into linked list at last before main task
   ua# 1024 0 fill \ clear user area
   cfa#   ua# 7 cells + ! \ store cfa# in IP
   ua# 32 cells +   ua# 4 cells + ! \ set SP
   ua# 98 1 + cells +   ua# 5 cells + ! \ set RP including zero
   ua# 162 cells +   ua# 6 cells + ! \ set auxP
   1   ua# 1 cells + ! \ mark ready
   up@ @ 0= if
      up@ ua# ! \  insert link back to main
      ua# up@ ! \ insert new task
   else
      up@ to_unext#
      begin
         unext# @ to_unext#
      unext# @ up@ = until
      up@ ua# ! \ insert link back to main
      ua# unext# ! \ insert new task
   then
; forgetLocals

: singletask \ stop cooperative multitasking
   0 background ! ;

' pause constant (pause)

: multitask \ start cooperative multitasking
   (pause) background ! ;


: prtTasks { , link# -- } \ print Tasks and their status
   cr
   up@ @ 0= if
      ." No Tasks."
   else
      up@ @ to_link#
      begin
         link# . space link# 32 - print$ link# 4 + @ . cr
         link# @ to_link#
      link# up@ = until
   then
; forgetLocals

: unlinkTask { task# , link# } \ remove Task from link list
   cr
   up@ @ 0= if
      ."   No Tasks."
   else
      up@ to_link#
      begin
         link# @ task# = if
            link# @ @ link# !
         then
         link# @ to_link#
      link# up@ = until
   then
   up@ @ up@ = if 0 up@ ! then \ was pointing to itself
; forgetLocals


\ Examples ##########################################################################
\ 57 constant ledPin \ P2
25 constant ledPin \ Pico

create blinkerT 1024 allot \ create user area

500 value bFreq#

: blinkTask \ example for multitasker
   begin
      getms bFreq# / 1 and ledPin pin!
      pause
   again
;

blinkerT ' blinkTask addTask \ insert task into linked list

variable cnt1

: counterTask \ example for multitasker
   begin
      cnt1 ++
      pause
   again
;
\ create counterT 1024 allot    counterT ' counterTask addTask

multitask \ activate background multitasking
scanSource

7 load \ editor
