\ Block 50 tests

: tst1 
   10 0 do 
      i . 
   loop 
;

\ €



\ macro and switch...case

: within { x# lo# hi# -- flag } \  true if n is within range of low and high inclusive
   x# lo# 1- >
   x# hi# 1+ < and 
; forgetLocals 

: eval$ ( stringaddr -- ) \ save inP evaluate restore inP
   inP @ >r evaluate r> inP ! ;

\ uses variable at offset 9 longs in user space 
: switch ( value -- ) \ save in switchvar
   s" up@ 9 cells + ! " eval$ ; immediate 
: case ( value -- ) \ case....break compare with switchvar 
   s" up@ 9 cells + @ = if " eval$ ; immediate
: <case> ( value1 value2 -- ) \ case....break compare within switchvar 
   s" up@ 9 cells + @ rot rot within if " eval$ ; immediate
: break ( -- ) \ case...break exits!
   s" exit then " eval$ ; immediate
   
: casetest ( val -- ) \ a test for switch....case...break
 switch
 1 case ." one" break
 2 case ." two" break
 3 case ." three" break
 4 10 <case> ." between four and ten" break
 ." default"
 ;


\ unlink and print tasks #######################################################

: prtTasks { , link# -- } \ print Tasks and their status
   cr
   up@ @ 0= if
      ." No Tasks."
   else   
      up@ @ to_link#
      begin
         link# . space link# 32 - print$ link# 4 + @ . cr
         link# @ to_link#
      link# up@ = until 
   then
;

: unlinkTask { task# , link# } \ remove Task from link list
   cr
   up@ @ 0= if
      ."   No Tasks."
   else   
      up@ to_link#
      begin
         link# @ task# = if
            link# @ @ link# !
         then
         link# @ to_link#
      link# up@ = until
   then
   up@ @ up@ = if 0 up@ ! then \ was pointing to itself
;



\ locals demo ################################################

: calcCheck { last# , check# -- endvalue } \ calculate a checksum of first bytes
   0 to_check#
   begin 
      last# c@
      +to_check#
      -1 +to_last# \ count down
   last# 0= until
   check# \ bring the sum to TOS
;
100 calcCheck .



\ scanSources

: scanDefs loc \ fills source field from actual buffer
   cr
   bBuf >a
   begin
      a> @ $FFFFFF and >c
      c> $203A0A = if \ found LF Colon Blank
         a> 3 + lineBuf$ copyword drop
         cr lineBuf$ print$
         lineBuf$ find$ >b \ gets lfa
         b> if   
            b> .
            actBlock @ 22 << a> 1+ +   b> 4 + ! 
         then
      then
      1 +>a
    a> c@ 0= until
endloc ;

: scanSource \ fills source fields from first buffers
   6 1 do
      cr ." Block " i .
      i block drop
      scanDefs
   loop
;



\ Background Blink via background or in Cog1
0 background !
forget tests
variable tests

57 constant ledPin
variable ledFlag
300 value blinkms#

: simpleBlink
   getms 9 >> 1 and ledPin pin! ;

' simpleBlink background !



: togLed 1 ledFlag +!   ledFlag @ 1 and ledPin pin! ;

: ms loc_a ( millisec -- ) \ pause for millisec
   getms >b 
   begin getms b> - a> = until 
endloc ;

\ : blink1 begin 300 ms togLed conkey until ;

: blink 300 0 do blinkms# ms togLed loop ;

create user1 1000 allot

\ 1 user1 ' blink cogstart \ ( COGnr userArea instruction -- )
\ €





\ ############################################################


: length$ loc_a ( addr1 -- n ) \ { give length of NULL terminated string
    0 >b \ in b ist die Laenge
    begin
    a> b> + c@ while \ nicht zu ende
        b> 1 + >b
    repeat
    b> \ gib das Ergebnis zurück
endloc ; \ }

: compare$ loc_a_b ( addr1 addr2 -- flag ) \ { comparison of 2 NULL terminated strings
    a> length$ b> length$ = >c \ in c ist das logische Ergebnis
    begin
    a> c@ b> c@ and while \ beide nicht zu ende
        a> c@ b> c@ = c> and >c \ auch diese beiden gleich ?
        a> 1 + >a
        b> 1 + >b
    repeat
    c> \ gib das logische Ergebnis zurück
endloc ; \ }




: printLine { address# , char# -- } \ print to line end
   begin
      address# c@ to_char#
      char# 31 > if 
         char# emit
         1 +to_address#
      then
   char# 32 < until
; forgetLocals

: findLineStart { addr# -- new_addr } \ scans until pos after CR, 0 for end
   begin
      addr# c@ dup 0= if endloc exit then \ end of text 0
      1 +to_addr#
   10 = until
   addr#
; forgetLocals

: cmpWord$ { w1# w2# , c1# c2# flag# -- flag# } \ compare limited by whitespace
   -1 to_flag#
   begin
      w1# c@ to_c1#
      w2# c@ to_c2#
      c1# 32 max   c2# 32 max   = flag# and to_flag#
      1 +to_w1#   1 +to_w2#
   c1# 33 <   c2# 33 < or   flag# 0= or until
   flag#
; forgetLocals
      
: findSource { wordname# , point# actLine# -- linestart# } \ find source of word in open block
   wordname# lineBuf$ cpy$
   bBuf to_point#
   begin
      point# findLineStart dup to_point# dup to_actLine#
      0= if endloc exit then
      actLine# 58 = if \ colon
         actLine# 2 + lineBuf$ cmpWord$ 
      else 0 then
   until
   actLine#
; forgetLocals

: prtDef ( <word> -- ) \ print def in act Block
   word findSource
   ?dup if printLine then
;






\ ############################################################
\ { modules http: //www.forth.org/fd/FD-V02N5.pdf
: INTERNAL ( -- addr ) context @ ( Start of hidden/local definitions ) ;
: EXTERNAL ( -- addr ) here@ ( Start of visible definitions. Adresse des aktuellen Linkfields ) ;
: MODULE ( addr1 addr2 -- ) ! ( Ueberspringen der Def zwischen INTERNAL und EXTERNAL ) ;

\ }

: prDefs loc \ prints 1st lines of buffer
   bBuf >a
   begin
      a> c@ >c 
      c> 58 = if 1 >d then \ set flag
      c> 10 = d> and if cr then
      c> 31 < if 0 >d then \ clear flag
      d> if c> emit then
      1 +>a
   c> 0= until       
endloc ;

: nxtWord ( -- address ) \ get next word of the input stream into lineBuf$
   begin \ skip leading whitespace
   inP @ c@ dup 0 <>   swap 33 < and while
      inP ++
   repeat
   inP @ lineBuf$ copyword inP !
   lineBuf$
;

: source ( <word> -- ) \ print source text
   
\ €

\ #########################################################################
: t1 loc_ab a> . b> . endloc ; 

: prtKeys begin wkey 27 = until ." End" ;

: prtComment loc_a ( pointer -- new pointer ) \ prt comments green from /_ or (_ to ) or lf
   a> 1+ c@ 32 <> if a> endloc exit then
   a> c@   dup 40 =   swap 92 = or if
      green
      begin 
         a> c@ >c
         c> emit
         1 +>a
      c> 41 =   c> 10 = or until
      normal
   then
   a>
endloc ;
   
: colBuf loc ( -- ) \ display bBuf in color
   bBuf >a
   begin 
      begin \ leading space cr or NULL
         a> c@ >c
         c> 0= if endloc exit then
         c> 32 =   c> 10 = or if \ blank or cr
            c> emit 1 +>a 
         then
      c> 32 > until
      a> prtComment >b
      a> b> = if
         a> lineBuf$ copyword >a
         lineBuf$ find$ >b \ find link field
         b> 0 > if b> prtCWord 
         else yellow lineBuf$ print$ normal
         then
      else          
         b> >a
      then
   again
endloc ;




\ ###############################################################
\ Background Blink in Cog1
57 constant ledPin
variable ledFlag
300 value blinkms#

: togLed 1 ledFlag +!   ledFlag @ 1 and ledPin pin! ;

: ms loc_a ( millisec -- ) \ pause for millisec
   getms >b 
   begin getms b> - a> = until 
endloc ;

\ : blink1 begin 300 ms togLed conkey until ;

: blink 300 0 do blinkms# ms togLed loop ;

create user1 1000 allot

\ 1 user1 ' blink cogstart \ ( COGnr userArea instruction -- )
\ €

\ ##################################################################

: tkey begin wkey dup . 27 = until ;
: tk2 20 0 do wkey loop 20 0 do . loop ;


\ ##################################################################
\ Block 10 Prime Benchmark
forget size

8192 constant size ( original: 8190 1024 )  
variable flags    size allot 

  
: do-prime \ calculate primes Byte benchmark
   cnt@ 
   flags size 1 fill ( set array )   
   0 ( 0 count )    
   size 0 do    
      flags i + c@ if    
         i dup + 3 +    
            ( dup . )  
         dup i +    
         begin dup size <    
         while    
            0 over flags + c!    
            over +    
         repeat    
         drop drop 1+    
      then    
   loop    
   .  
   cnt@ swap - dup . 200 / .   
;   
 ( do-prime ) 

\ do-prime  1899 51165904 255829 0.26s f. 1 Durchlauf

\ €


\ { Screen control and colors https://en.wikipedia.org/wiki/ANSI_escape_code#Terminal_output_sequences 
: scolor ( color -- ) 27 emit 91 emit 48 + emit 109 emit ;
: bold 1 scolor ; : normal 0 scolor ;
: fcolor ( col ) 27 emit 91 emit 51 emit 48 + emit 109 emit ;
: red 1 fcolor ; : green 2 fcolor ; : yellow 3 fcolor ; : blue 4 fcolor ;

: .2d ( n -- ) \ { print 2 digits without blank
    dup 9 > if 
        10 /mod 
        48 + emit
    then
    48 + emit 
; \ }
            
: at-xy ( col row -- ) \ { position cursor at col row, starting with 0 0
    27 emit 91 emit
    1+ .2d 
    59 emit \ ;
    1+ .2d
    72 emit
; \ }

: page ( -- ) \ { clear page
    27 emit 91 emit
    50 emit
    74 emit
    0 0 at-xy
; \ }
 
\             ISNORMAL, ISLOOP, ISSTRUCT, ISDATA, ISIO, ISASS
create colTab 7 c, 1 c, 6 c, 4 c, 7 c, 7 c,

: prtCWord loc_a ( lfa -- ) \ print word in color
   a> 8 + c@   
   $7 and colTab + c@ fcolor \ get color
   a> 9 + print$
   normal
endloc ;

: cwords loc \ print words in color
   cr
   context @ >a
   begin
      a> prtCWord space
      a> @ >a \ crawl link fields
   a> 0= until
endloc ;

create wordBuf$ 30 allot

: copyword loc_ab ( source dest -- new_source ) 
   begin 
      a> c@ >c \ getchar
      c> 32 > if 
         c> b> c! 
         1 +>a   1 +>b
         then
   c> 33 < until
   0 b> c! \ end mark
   a>
endloc ;

: colBuf loc ( -- ) \ display bBuf in color
   bBuf >a
   begin 
      begin \ leading space cr or NULL
         a> c@ >c
         c> 0= if endloc exit then
         c> 32 =   c> 10 = or if \ blank or cr
            c> emit 1 +>a 
         then
      c> 32 > until
      a> wordBuf$ copyword >a
      wordBuf$ find$ >b \ find link field
      b> 0 > if b> prtCWord 
      else yellow wordBuf$ print$ normal
      then
   again
endloc ;

